<?php if (!defined('PmWiki')) exit();
/**
 * jscookmenu.php
 * @author V.Krishn (vkrishn@ainsteps.net)
 * @note This file is part of Cookbook recipe "Jscm" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 *
 * @category pmwiki/cookbook
 * @package jscm
 * @copyright Copyright (c) 2005-2009 V.Krishn (vkrishn@ainsteps.net)
 * @license GPL
 * @version 2.2.0
 */

global $Jscm;
if ( ! IsEnabled($EnableJscm, 0)) return;

## Current script variables
    if ( ! defined(DS) ) { define('DS', DIRECTORY_SEPARATOR); }
    $Jscm['Current']['dir'] = dirname(__FILE__);
    $EnableJscmDebug = 0; # 0=no debug, 1=debug messages, 2=all
    $Jscm['debug']['msg'] = array();

## Get cookbook/modules meta and version variables
## @todo xml version of the metapage
    if (file_exists($Jscm['Current']['dir'] . DS . "version.php")) {
      include_once($Jscm['Current']['dir'] . DS . "version.php");
    }

## Get wiki group and pagename for use
    $Jscm['page']['CurrentGroup'] = FmtPageName('$Group', $pagename);
    $Jscm['page']['CurrentName'] = FmtPageName('$Name', $pagename);

## Set default values for GROUP and default layermenu MENU script(wiki page)
    SDV($Jscm['default']['MenuGroupReserved'], 'Jscm'); #not implemented
    SDV($Jscm['default']['MenuPageGroup'], 'Content');
    SDV($Jscm['default']['MenuPageName'], 'Jscm');

// ========================================================
 /*
   NOTE: CAUTION
   Use of this recipe lets you insert arbitrary JavaScript Code.
   DO NOT dissable the security code in "jscookmenu.php".
   Make appropriate settings with the default password = menupass
     in jscookmenu.php or in config.php if commenting below.
   Read main documentation on page protection and passwords.
   Simple security precaution below
 */
  global $DefaultPasswords;
  if ($Jscm['default']['MenuPageName'] === substr($pagename, -6)) {
    $DefaultPasswords['edit'] = crypt('menupass');
    $DefaultPasswords['attr'] = crypt('menupass');
  }
// ========================================================

## Set modules/cookbook install variables.
## Change these values accordingly.
    SDV($Jscm['Install']['location'], '0'); # 0=field, 1=farm, 2=others
    SDV($Jscm['Install']['path'], 'cookbook'); # relative to field or farm
    SDV($Jscm['Install']['dir'], 'jscm'); # folder where installed
    SDV($Jscm['Install']['icon']['dir'], 'icons'); # icons to be used in menus


    // --------------------------------------
    // Would not require to edit below this
    // --------------------------------------



// //////////////////////////////////////////////////////////
//(:jscmDraw id menu orient theme:)
//    id - unique id
//    menu - menu name
//    orient - hbr,hbl,hur,hul,vbr,vbl,vur,vul
//    theme - cmThemeMiniBlack,cmThemePanel,cmThemeIE...
// //////////////////////////////////////////////////////////

Markup('jscmDraw','directives','/\\(:jscmDraw(.*?):\\)/e',"'<:block>'.jscmDraw('$1')");
Markup('jscmMain','directives','/\\(:jscmMain:\\)/e',"'<:block>'.jscmMain('$1')"); #todo
Markup("~#~",">inline",'/~#~/',"<span></span>");

function jscmMain() { #todo
  return;
  $cmHtmlFmt2 = keep($cmHtmlFmt);
  return $cmHtmlFmt2;
}

function jscmDraw($params) {
  global $Jscm, $jscmInstallUrl,
         $HTMLHeaderFmt, $HTMLFooterFmt,
         $EnableJscmDebug;
  static $jscmDrawCount;
  $jscmDrawCount++;
  include_once('scripts/functions.php');
  include_once('scripts/set_path_file.php');
  jscm_init_lib();

  $jscmInstallDir = &$Jscm['Current']['dir'];
  $jscmInstallUrl = &$Jscm['Install']['dirUrl'];
  $jscmIconDir = &$Jscm['Install']['icon']['dirFmt'];
  $jscmIconUrl = &$Jscm['Install']['icon']['dirUrl'];
  include_once('scripts/set_args_map.php');

  include_once('scripts/set_menu_file.php');

  $cmDrawMap = jscm_get_drawmap($params);
  foreach ($cmDrawMap as $k => $v) { $$k = $v; }
  if($EnableJscmDebug > 0) {
    $Jscm['debug']['msg']['cmDrawMap'][] = $cmDrawMap;
    //$Jscm['debug']['msg']['cmTheme'][] = $cmTheme;
    //$Jscm['debug']['msg']['cmThemeDir'][] = $cmThemeDir;
    //$Jscm['debug']['msg']['cmThemeBase'][] = $cmThemeBase;
    //$Jscm['debug']['msg']['cmScriptDUrl'][] = $jscmInstallUrl;
  }
  //$cmScriptDUrlPath = $thisScriptDUrlPath;
  if ( ! isset($HTMLHeaderFmt[$cmTheme])) {
    $HTMLHeaderFmt[$cmTheme] =
        jscm_get_theme_fmt($cmTheme,$cmThemeDir,$cmThemeBase,$jscmInstallUrl);
  }
  $args = ParseArgs($params);
  $count = count($args[""]);
  $cmHtmlFmt = jscm_set_draw_fmt($cmDrawMap, $count);
  if($EnableJscmDebug > 0) {
    //$Jscm['debug']['msg']['cmHtmlFmt'][] = $cmHtmlFmt;
  }

  ## Debug
  $jscmDebugMsg = JscmDebug($EnableJscmDebug);
  if($jscmDebugMsg) {
    @$HTMLFooterFmt['jscm_DEBUG'] =
        '<pre>' . $jscmDebugMsg . '</pre>' . "\n";
  }

  if($cmHtmlFmt != "") {
    return keep(
    "\n<!--jscm id $cmID-->$cmHtmlFmt \n<!--/jscm id $cmID-->"
    );
  }


}




